{
  Autor: Michael Springwald

  Erstellt: Samstag, 29.September.2007
  Updates:  Dienstag, 30.Oktober.2007

}

unit uplaylistM3U;

{-$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, uplaylistbase;

type

  { TPlayListM3U }

  TPlayListM3U = class(TPlaylistBase)
  private

  protected

  public
    procedure SaveToFile(const aFileName:String = ''); override;
    procedure LoadFromFile(const aFileName:String); override;

  end;

implementation

{ TPlayListM3U }

procedure TPlayListM3U.SaveToFile(const aFileName: String);
var
  i:integer;
  m3uFile:TStringList;
  info:TInfo;
begin
  m3uFile:=TStringList.Create;
  try
    if ext <> '' then
      m3uFile.Add(ext);

    for i:=0 to PlayListItems.count-1 do begin
      info:=TInfo(PlayListItems.Objects[i]);

      if info.Kommentar <> '' then m3uFile.Add(info.Kommentar);
      m3uFile.Add(info.FileName);
    end;
    m3uFile.SaveToFile(aFileName);
  finally
    m3uFile.Free;
  end;
end;

procedure TPlayListM3U.LoadFromFile(const aFileName: String);
var
  tmp:TStrings;
  i,m:Integer;
  str:String;
  Item:TInfo;
begin
  tmp := TStringList.Create;
  try
    with tmp do begin
      LoadFromFile(aFileName); m:=0;
      if UpperCase(Strings[0]) = '#EXTM3U' then begin
        m:=1;
        ext:='#EXTM3U';
      end
      else
        ext:='';
    
      i:=m;
      while i <= Count-1 do begin
        str:=strings[i]; Item:=TInfo.Create;

        if (str <> '') then
        begin
          if str[1] = '#' then
          begin
            Item.Kommentar := str;
            Item.FileName := strings[i+1];

            if AnsiSameText(Copy(str, 1, 8), '#extinf:') then
            begin
              System.Delete(str, 1, 8);
              if Pos(',', str) > 0 then
                System.Delete(str, Pos(',', str), MaxInt);
              Item.Playtime := StrToIntDef(str, 0);
            end;

            if OhneExt then
              PlayListItems.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item)
            else
              PlayListItems.AddObject(ExtractFileName(Item.FileName),Item);

            inc(i,2);
          end
          else
          begin
            Item.Kommentar := '';
            Item.FileName := strings[i];

            if OhneExt then
              PlayListItems.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item)
            else
              PlayListItems.AddObject(ExtractFileName(Item.FileName),Item);

            inc(i);
          end;
        end;
      end; // for i:=0
    end; // tmp
  finally
    tmp.free;
  end;
end;

end.

