{
  Autor: Michael Springwald

  Erstellt: Samstag, 29.September.2007
  Updates:  Sontag, 14.Oktober.2007, Dienstag, 30.Oktober.2007
            Mittwoch, 31.Oktober.2007

}

unit uplaylistenmanger;

{-$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,uplaylistbase,uplaylistM3U,contnrs,dialogs;

type

  { TPlaylistenManger }

  TPlaylistenManger = class
  private
    fOnAddPlayListe: TOnAddPlayliste;
    fOnGetPlayListeItem:TOnGetPlaylisteItem;
    fPlayliste: TPlaylistBase;
    fPlayListItems: TStrings;
    procedure SetPlaylistItems(const AValue: TStrings);
    procedure InitPlaylist(const aFileName:String; var aPlayliste:TPlaylistBase);
  protected

  public
    _ext:string;
    FileName:String;
    OhneExt:Boolean;
    property PlaylistItems: TStrings read fPlaylistItems write SetPlaylistItems;
    property Playliste: TPlaylistBase read fPlayliste;

    constructor Create;
    destructor Destroy; override;

    procedure SaveToFile(const aFileName:String = '');
    procedure LoadFromFile(const aFileName:String = '');

    procedure ClearPlayliste;
    procedure AddPlayListe(AddListe:TStrings);
    procedure DelPlayliste(const aIndex:Integer);

    function GetPlayListenItem(const aIndex:Integer):TInfo;

  published
    property onAddPlayListe:TOnAddPlayliste read fOnAddPlayListe write FonAddPlayListe;
    property OnGetPlayListeItem:TOnGetPlaylisteItem read fOnGetPlayListeItem write fOnGetPlayListeItem;

  end;

implementation

{ TPlaylistenManger }

procedure TPlaylistenManger.SetPlaylistItems(const AValue: TStrings);
begin
  fPlaylistItems := AValue;
  if assigned(fPlayListe) then
    fPlayliste.PlayListItems := AValue;
end;

procedure TPlaylistenManger.InitPlaylist(const aFileName: String; var aPlayliste: TPlaylistBase);
var
  ext:String;
begin
  APlayliste := nil;
  
  ext := AnsiUpperCase(ExtractFileExt(aFileName));
  if ext = '.M3U' then aPlayliste:=TPlayListM3U.Create;
//  if ext = 'PLS' then aPlayliste:=TPlayList.Create;
end;

constructor TPlaylistenManger.Create;
begin
  inherited Create;
  FileName:=''; OhneExt:=true;
end;

destructor TPlaylistenManger.Destroy;
begin
  inherited;
end;

procedure TPlaylistenManger.SaveToFile(const aFileName: String);
begin
//  InitPlaylist(ExtractFileName(aFileName), fPlayliste);       // Instanz neu anlegen? Alle Wert berschreiben?
  Playliste.ext := _ext;
  Playliste.PlayListItems := PlayListItems;
  Playliste.SaveToFile(aFileName);
end;

procedure TPlaylistenManger.LoadFromFile(const aFileName: String = '');
var
  i:integer;
begin
  InitPlaylist(ExtractFileName(aFileName), fPlayliste);
  if assigned(Playliste) then
  begin

    Playliste.OhneExt:=OhneExt;
    Playliste.PlayListItems := PlayListItems;
    Playliste.LoadFromFile(aFileName);

//    writeln(PlayListItems.text);

  //  PlayListItems.Assign(Playliste.PlayListItems);

    _ext:=Playliste.ext;
  end
  else
    ShowMessage('Unbekannter Playlistentyp!');
end;

procedure TPlaylistenManger.ClearPlayliste;
begin
 //PlayListItems.Clear;
end;


procedure TPlaylistenManger.AddPlayListe(AddListe:TStrings);
var
  i:Integer;
  info:TInfo;
begin
  for i:=0 to AddListe.Count-1 do begin
   info:=TInfo.Create;

   info.FileName:=AddListe[i];
   if OhneExt then
     PlayListItems.AddObject(SplitStr(ExtractFileName(info.FileName),'.'),info)
   else
     PlayListItems.AddObject(ExtractFileName(info.FileName),info)
  end;
end;

procedure TPlaylistenManger.DelPlayliste(const aIndex: Integer);
begin
  PlayListItems.Delete(aIndex);
end;

function TPlaylistenManger.GetPlayListenItem(const aIndex: Integer): TInfo;
begin

  result.FileName:=TInfo(PlayListItems.Objects[aindex]).FileName;
  result.Kommentar:=TInfo(PlayListItems.Objects[aindex]).Kommentar;
end;

end.

